#!/usr/bin/env python
from datetime import date, timedelta
from dateutil.relativedelta import relativedelta
import re
from bs4 import BeautifulSoup
from pathlib import Path
from locale import setlocale, LC_TIME

here = Path('.')
setlocale(LC_TIME, 'fr_FR.utf8')
previous_month = date.today() - relativedelta(months=1)

template = lambda content: (here / "template.mjml").read_text().replace('%content%', content).replace('%year%', str(date.today().year)).replace('%month%', f'{previous_month:%B}')
content = (here / str(date.today().year) / f'{previous_month:%B}.html').read_text()

def html_to_mjml(content: str) -> str:
    # parsing html with regex haha
    heading_pattern = re.compile(r'(<h([2-6])>[^<]+</h\2>)')
    content = BeautifulSoup(content, features="lxml")('body')[0].decode_contents()
    matches = heading_pattern.findall(content)
    for i, (match, _) in enumerate(matches):
        if 0 < i < len(matches) - 1:
            content = content.replace(str(match), '</mj-text></mj-column></mj-section><mj-section><mj-column><mj-text>' + str(match))

    return '<mj-section><mj-column><mj-text>' + str(content) + '</mj-text></mj-column></mj-section>'


(here / str(date.today().year) / f'{previous_month:%B}.mjml').write_text(template(html_to_mjml(content)))
